(* stampa in ordine inverso elementi inseriti da input e memorizzati in una lista *)
(* versione con inserimento degli elementi in _testa_ alla lista *)
Program ListaReverse2;

type	lista = ^cella;
	posizione = lista;

	cella = record
		valore : integer;
		successivo : posizione
	end;

var	L : lista;

Procedure Inserisci();
var 	ptmp : posizione;
	numero : integer;
Begin
	numero := 0;
	L := NIL;

	while numero >= 0 do
	Begin
		Write('Numero da inserire: ');
		Readln(numero);
		
		if (numero >= 0) then 
		Begin
			(* inserisco in testa invece che in coda *)
			ptmp := NIL;
			new(ptmp);
			ptmp^.valore := numero;
			ptmp^.successivo := L;

			L := ptmp
		End
	End
End;

Procedure Visita();
var	tmp : posizione;
Begin

	tmp := L;

	while tmp<>NIL do
	Begin
		writeln(tmp^.valore);
		tmp := tmp^.successivo
	End
End;

Begin
	Inserisci();
	Visita()
End.

